#ifndef UWATER_FRAME_FUNC_REPLAY_BLE_H
#define	UWATER_FRAME_FUNC_REPLAY_BLE_H
#include "sys_config.h"
#include "type.h"
#if PRODUCT_BLE_SS
//----------------------------------------------ԼЭ----------------------------------------/ 
/**
ݱʶ00ʼ
Ӷȡ
*/
//
#define BLE_READ_DATA_DI0                 0x00
#define BLE_READ_DATA_DI1                 0x50
//
#define BLE_VALVE_CTRL_DI0                0x01
#define BLE_VALVE_CTRL_DI1                0x50
//ȡַ
#define BLE_READ_MET_DI0                  0x02
#define BLE_READ_MET_DI1                  0x50
//ñַ
#define BLE_SET_MET_DI0                   0x03
#define BLE_SET_MET_DI1                   0x50
//ñ
#define BLE_SET_DATA_DI0                  0x04
#define BLE_SET_DATA_DI1                  0x50
//
#define BLE_SET_BOOT_DI0                  0x05
#define BLE_SET_BOOT_DI1                  0x50
//汾
#define BLE_READ_VERSION_DI0              0x06
#define BLE_READ_VERSION_DI1              0x50
//ʱ
#define BLE_READ_TIME_DI0                 0x07
#define BLE_READ_TIME_DI1                 0x50
//ñʱ
#define BLE_SET_TIME_DI0                  0x08
#define BLE_SET_TIME_DI1                  0x50
//Լ
#define BLE_TEST_START_DI0                0x09
#define BLE_TEST_START_DI1                0x50
//ѯԼ
#define BLE_TEST_READ_DI0                 0x0A
#define BLE_TEST_READ_DI1                 0x50
//У׼
#define BLE_ADJUST_START_DI0              0x0B
#define BLE_ADJUST_START_DI1              0x50
//ѯУ׼
#define BLE_ADJUST_READ_DI0               0x0C
#define BLE_ADJUST_READ_DI1               0x50
//SOE
#define BLE_READ_SOE_DI0                  0x0D
#define BLE_READ_SOE_DI1                  0x50
//Ƿѹֵ
#define BLE_READ_PWLOW_DI0                0x0E
#define BLE_READ_PWLOW_DI1                0x50
//Ƿѹֵ
#define BLE_SET_PWLOW_DI0                 0x0F
#define BLE_SET_PWLOW_DI1                 0x50
//EE
#define BLE_READ_EEPROM_DI0               0x10
#define BLE_READ_EEPROM_DI1               0x50
//EEPROM
#define BLE_ERASE_EEPROM_DI0              0x11
#define BLE_ERASE_EEPROM_DI1              0x50
//RAM
#define BLE_READ_RAM_DI0                  0x12
#define BLE_READ_RAM_DI1                  0x50
//ȡ澯ֵʱ
#define BLE_READ_OVERFLOW_DI0             0x13
#define BLE_READ_OVERFLOW_DI1             0x50
//ù澯ֵʱ
#define BLE_SET_OVERFLOW_DI0              0x14
#define BLE_SET_OVERFLOW_DI1              0x50
//ȡ澯ֵʱ
#define BLE_READ_ROVERFLOW_DI0            0x15
#define BLE_READ_ROVERFLOW_DI1            0x50
//ù澯ֵʱ
#define BLE_SET_ROVERFLOW_DI0             0x16
#define BLE_SET_ROVERFLOW_DI1             0x50
//ս
#define BLE_READ_DAILY_DI0                0x17
#define BLE_READ_DAILY_DI1                0x50
//½
#define BLE_READ_MONTH_DI0                0x18
#define BLE_READ_MONTH_DI1                0x50
//MCU
#define BLE_RESET_MCU_DI0                 0x19
#define BLE_RESET_MCU_DI1                 0x50
//ù
#define BLE_SET_CONFIG_DI0                0x1A
#define BLE_SET_CONFIG_DI1                0x50
//˲ʱ¶
#define BLE_READ_FLOWTEMP_DI0             0x1B
#define BLE_READ_FLOWTEMP_DI1             0x50
//춨
#define BLE_ENTER_TEST_DI0                0x1C
#define BLE_ENTER_TEST_DI1                0x50
//춨
#define BLE_READ_TEST_DI0                 0x1D
#define BLE_READ_TEST_DI1                 0x50
//˳춨
#define BLE_EXIT_TEST_DI0                 0x1E
#define BLE_EXIT_TEST_DI1                 0x50
//ĳʷ
#define BLE_READ_HIS_DI0                  0x1F
#define BLE_READ_HIS_DI1                  0x50

//OTA־
#define BLE_OTA_NOTIC_DI0                 0x80
#define BLE_OTA_NOTIC_DI1                 0x50

typedef enum{	
	BLE_STATE_S0 = 0,
	BLE_STATE_S1,
	BLE_STATE_S2,
	BLE_STATE_S3,
	BLE_STATE_S4
}TYP_STATE_BLE;

#define PACK_NUM_GPRS  155
//ȡ״̬
UNION_4U8TOU32 getBleWetState(void);
//Լݴ洢ֳʼ
void DataStoreInit(void);
//Լݴ洢״̬
void DataStoreMachine(void);
//Լݴ洢ж
u8 DataStoreIfIdle(void);
	
u8 crack_frame_BLE(u16 frame_lenth,u8 *frame_buffer);
//ˮԼ
u8 up_deal_code_ble(void);
void Frame_ResetDealState_BLE(void);
//Ӧ֡
void Frame_ack_BLE(u8* p_send_buf, u16* p_send_len);

u32 sys_get_net_state(void);
void setBleReadAccessFlag(u8 data);

#endif
#endif	


