/***********************************************************************************
 * @Copyright (c)	:(C)2017, Qindao ieslab Co., Whn
 * @FileName   	  :stm32_lcd_driver.c
 * @Author       	:Team
 * @Version      	:V1.0
 * @Date         	:2017-8-25
 * @Description	:the function of the entity of system processor
 ************************************************************************************/
 
/* Includes ------------------------------------------------------------------*/
#include "UWater_lcd_driver.h"
#include "UWater_timer1uS_driver.h"

/* Private variables ---------------------------------------------------------*/
//LCD_HandleTypeDef hlcd; /*xixiSTM32صĽṹ*/	
static u8 s_display_num_state; //ʾ״̬״̬
//static u8 s_display_fun_state; //ʾַ̻״̬״̬

////////////////////////////////xixiַ̻ص״̬TOP////////////////////////////////////
static u16 s_seg_flag; //ӿڵñ־λ //gaishanxiugai ʾ10, u8Ϊu16
static u8 s_seg_data[10]; //10ݻ  //gaishanxiugai
static u8 s_valve_state; //״̬
static u8 s_val_state; //صѹ״̬
static u8 s_low_flow_state; //״̬
static u8 s_alarm_state; //
static u8 s_failure_state; //
static u8 s_active_RF_state=0; //ͨ
static u8 s_active_RF_state_old=0;
//static u8 s_yuan_state; //Ԫ
//static u8 s_pay_money_state; //ɷ
//static u8 s_price_state; //
//static u8 s_lost_state; //ʣ
//static u8 s_buy_state; //


static u8 s_fun_flag; //ӿڵñ־λ
static FUN_DATA s_fun_data; //ַ̻λǷʾ


//static u8 s_lcd_display_state = 0;       //lcdʾ״̬״̬
//static u16 s_seg_flag = 0;                //ݽӿڵñ־λ
//static u8 s_fun_flag = 0;                //ַ̻ӿڵñ־λ
//static FUN_DATA s_fun_data;              //ַ̻λǷʾ
//static u8 s_seg_data[11] = {0};           //8ݻ0 1 2 3 4 5 6 7 x x 10
//static u8 s_valve_state = 2;             //״̬
//static u8 s_val_state = 0;               //صѹ״̬
//static u8 s_alarm_state = 0;             //״̬
////static u8 s_active_GPRS_state = 0;       //GPRSͨ״̬
//static u8 s_please_pay_state = 0;        //ɷ-Ƿ״̬
////////////////////////////////xixiַ̻ص״̬BOTTOM////////////////////////////////////


static u32 s_lcd_us_num = 0;             //lcd΢뼶ʱֵ


static const u32 SEG_A_BUF_D4[10]={A0_COM4, A1_COM4, A2_COM4, A3_COM4, A4_COM4, A5_COM4, A6_COM4, A7_COM4, A8_COM4, A9_COM4};
static const u32 SEG_B_BUF_D3[10]={B0_COM3, B1_COM3, B2_COM3, B3_COM3, B4_COM3, B5_COM3, B6_COM3, B7_COM3, B8_COM3, B9_COM3};
static const u32 SEG_C_BUF_D2[10]={C0_COM2, C1_COM2, C2_COM2, C3_COM2, C4_COM2, C5_COM2, C6_COM2, C7_COM2, C8_COM2, C9_COM2};
static const u32 SEG_D_BUF_D1[10]={D0_COM1, D1_COM1, D2_COM1, D3_COM1, D4_COM1, D5_COM1, D6_COM1, D7_COM1, D8_COM1, D9_COM1};
static const u32 SEG_E_BUF_D2[10]={E0_COM2, E1_COM2, E2_COM2, E3_COM2, E4_COM2, E5_COM2, E6_COM2, E7_COM2, E8_COM2, E9_COM2};
static const u32 SEG_F_BUF_D4[10]={F0_COM4, F1_COM4, F2_COM4, F3_COM4, F4_COM4, F5_COM4, F6_COM4, F7_COM4, F8_COM4, F9_COM4};
static const u32 SEG_G_BUF_D3[10]={G0_COM3, G1_COM3, G2_COM3, G3_COM3, G4_COM3, G5_COM3, G6_COM3, G7_COM3, G8_COM3, G9_COM3};
/* Private function prototypes -----------------------------------------------*/
//xixiGPIO ĳʼ
//static void LcdClockConfigure(void);
//static void LcdInitConfigure(LCD_HandleTypeDef *hlcd);
//static void LcdMspInit(LCD_HandleTypeDef* hlcd);
//static void LcdGpioInit(GPIO_TypeDef *GPIOx, LCD_GPIO_InitTypeDef *GPIO_Init);

static void LcdGpioInit(void);//xixiGPIOʼ

void LcdDataSet(u8 lcddata_data, u8 num);
void LcdWriteData(u8 num,u32 data1,u32 data2,u32 data3,u32 data4);
//static void LcdClearData(u8 num);
static void LcdTimeOut(void);

void LcdDisplayLowFlowAlarm(u8 flag);
void LcdDisplayFailure(u8 flag);

/**************************************************************
Function:static void LcdGpioInit(LCD_HandleTypeDef* hlcd)
Description: GPIOʼ
Input
Return:
Others:MainSpaceڲӿ
**************************************************************/
//xixi ioҪ޸
static void LcdGpioInit(void)
{
		Gpio_SetAnalogMode(GpioPortA, GpioPin9);  //COM0
		Gpio_SetAnalogMode(GpioPortA, GpioPin10); //COM1
		Gpio_SetAnalogMode(GpioPortA, GpioPin11); //COM2
		Gpio_SetAnalogMode(GpioPortA, GpioPin12); //COM3   

		Gpio_SetAnalogMode(GpioPortC, GpioPin4);  //S1-SEG15
		Gpio_SetAnalogMode(GpioPortC, GpioPin5);  //S2-SEG14
		Gpio_SetAnalogMode(GpioPortB, GpioPin0);  //S3-SEG13
		Gpio_SetAnalogMode(GpioPortB, GpioPin1);  //S4-SEG12
		Gpio_SetAnalogMode(GpioPortB, GpioPin2);  //S5-SEG11
		Gpio_SetAnalogMode(GpioPortE, GpioPin12); //S6-SEG51
		Gpio_SetAnalogMode(GpioPortE, GpioPin13); //S7-SEG50
		Gpio_SetAnalogMode(GpioPortE, GpioPin14); //S8-SEG49
		Gpio_SetAnalogMode(GpioPortB, GpioPin10); //S9-SEG10
		Gpio_SetAnalogMode(GpioPortB, GpioPin11); //S10-SEG9
		Gpio_SetAnalogMode(GpioPortB, GpioPin12); //S11-SEG8
		Gpio_SetAnalogMode(GpioPortB, GpioPin13); //S12-SEG7
		Gpio_SetAnalogMode(GpioPortB, GpioPin14); //S13-SEG6
		Gpio_SetAnalogMode(GpioPortB, GpioPin15); //S14-SEG5
		Gpio_SetAnalogMode(GpioPortD, GpioPin8);  //S15-SEG47
		
		Gpio_SetAnalogMode(GpioPortD, GpioPin9);  //S16-SEG46
		Gpio_SetAnalogMode(GpioPortD, GpioPin10); //S17-SEG45
		Gpio_SetAnalogMode(GpioPortD, GpioPin11); //S18-SEG44
		Gpio_SetAnalogMode(GpioPortC, GpioPin6);  //S19-SEG4
		Gpio_SetAnalogMode(GpioPortC, GpioPin7);  //S20-SEG3
		Gpio_SetAnalogMode(GpioPortC, GpioPin8);  //S21-SEG2
		Gpio_SetAnalogMode(GpioPortC, GpioPin9);  //S22-SEG1
		Gpio_SetAnalogMode(GpioPortA, GpioPin8);  //S23-SEG0

		Gpio_SetAnalogMode(GpioPortB, GpioPin3);  //VLCDH
		Gpio_SetAnalogMode(GpioPortB, GpioPin4);  //VLCD3
		Gpio_SetAnalogMode(GpioPortB, GpioPin5);  //VLCD2
		Gpio_SetAnalogMode(GpioPortB, GpioPin6);  //VLCD1
		
}

/* Functions -------------------------------------------------------*/
/*************************************************
Function: void LcdInit(void)
Description: Lcdʼ
Input
Return:
Others:MainSpaceһӿڣϵʼ
*************************************************/
void LcdInit(void)
{	
	stc_lcd_cfg_t LcdInitStruct;
	stc_lcd_segcom_t LcdSegCom;

	DDL_ZERO_STRUCT(LcdInitStruct);
	DDL_ZERO_STRUCT(LcdSegCom);
	
	LcdGpioInit();        ///LCD segcom IO
	
	Sysctrl_SetPeripheralGate(SysctrlPeripheralLcd,TRUE);           ///< LCDʱ
  
  	LcdSegCom.u32Seg0_31 = 0xffff0000;                              ///< LCD_POEN0Ĵ SEG0~SEG15
	LcdSegCom.stc_seg32_51_com0_8_t.seg32_51_com0_8 = 0xffffffff;   ///< ʼLCD_POEN1Ĵ ȫر˿
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Com0_3 = 0;          ///< ʹCOM0~COM3
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Mux = 0;             ///< Mux=0,Seg32_35=0,BSEL=LcdBias3ʾ:ѡⲿݹģʽ
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg32_35 = 0x00;		///< Seg32_35 ⲿݵ
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg44 = 0;
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg45 = 0;
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg46 = 0;
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg47 = 0;
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg49 = 0;
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg50 = 0;
	LcdSegCom.stc_seg32_51_com0_8_t.segcom_bit.Seg51 = 0;
	Lcd_SetSegCom(&LcdSegCom);                                     ///< LCD COMSEG˿
	
	//M0P_LCD->CR0_f.CONTRAST = 0x0;							   ///< Աȶȵ(ڲģʽЧ)
	
	LcdInitStruct.LcdBiasSrc = 	LcdExtCap;                          ///< ݷѹģʽҪⲿ·
	LcdInitStruct.LcdDuty = 	LcdDuty4;                           ///< 1/4duty
	LcdInitStruct.LcdBias = 	LcdBias3;                           ///< 1/3 BIAS
	LcdInitStruct.LcdCpClk =	LcdClk2k;                           ///< ѹʱƵѡ2kHz ??
	LcdInitStruct.LcdScanClk = 	LcdClk512hz;                        ///< LCDɨƵѡ        Hz
	LcdInitStruct.LcdMode = 	LcdMode1;                           ///< ѡģʽ0
	LcdInitStruct.LcdClkSrc = 	LcdRCL;                             ///< LCDʱѡRCL
	LcdInitStruct.LcdEn   = 	LcdEnable;                          ///< ʹLCDģ
	Lcd_Init(&LcdInitStruct);
	
	Lcd_ClearDisp();             ///< 

//xixi״̬ʼָԴһ,. top

	//õı־λ״̬ʼ
	s_display_num_state=0;  //ʾ״̬״̬
	s_seg_flag=0; //ӿڵñ־λ
	s_valve_state=0;//״̬ 
	s_val_state=0; //صѹ״̬
	s_low_flow_state=0; //״̬
	s_alarm_state=0; //
	s_failure_state=0; //
	s_active_RF_state=0; //ͨ
	// s_yuan_state=0; //Ԫ
	// s_pay_money_state=0; //ɷ
	// s_price_state=0; //
	// s_lost_state=0; //ʣ
	// s_buy_state=0; //
	s_fun_flag=0; //ӿڵñ־λ
	s_fun_data.word =0;//ַ̻λǷʾ

//xixi״̬ʼָԴһ,. bottom

}


/*************************************************
Function: void LcdMachineDriver(void)
Description:LCD
Input:
Return:
Others:MainSpaceڶӿڣӿ
*************************************************/
void LcdMachineDriver(void)//ӿ
{
	switch (s_display_num_state)
	{
		case LCD_DISPLAY_S0:
		{
			if ((s_fun_flag)||(s_seg_flag))
			{
				s_display_num_state = LCD_DISPLAY_S1;
				s_lcd_us_num = Timer1usGetTick();			
			}
			break;
		}
		case LCD_DISPLAY_S1:
		{
			//if ((((hlcd.Instance->SR) & LCD_FLAG_UDR)==LCD_FLAG_UDR) == RESET)//xixiжٿһ
			if(1)//xixiԭжRAMǷд,ڻƽ̨û,if(1)
			{ 
				if (s_fun_flag)//ַ̻ʾ
			  {				
					if (s_fun_data.seg.T1 != _FUN_T1)
					{					
						_FUN_T1 = s_fun_data.seg.T1;
					}
					if (s_fun_data.seg.T2 != _FUN_T2)
					{
						_FUN_T2 = s_fun_data.seg.T2;
					}
					if (s_fun_data.seg.T3 != _FUN_T3)
					{
						_FUN_T3 = s_fun_data.seg.T3;
					}
					if (s_fun_data.seg.T4 != _FUN_T4)
					{
						_FUN_T4 = s_fun_data.seg.T4;
					}
					if (s_fun_data.seg.T5 != _FUN_T5)
					{
						_FUN_T5 = s_fun_data.seg.T5;
					}
					if (s_fun_data.seg.T6 != _FUN_T6)
					{
						_FUN_T6 = s_fun_data.seg.T6;
					}
					if (s_fun_data.seg.T7 != _FUN_T7)
					{
						_FUN_T7 = s_fun_data.seg.T7;
					}
					if (s_fun_data.seg.T8 != _FUN_T8)
					{
						_FUN_T8 = s_fun_data.seg.T8;
					}
					if (s_fun_data.seg.T10 != _FUN_T10)
					{
						_FUN_T10 = s_fun_data.seg.T10;
					}
					if (s_fun_data.seg.T11 != _FUN_T11)
					{
						_FUN_T11 = s_fun_data.seg.T11;
					}
					if (s_fun_data.seg.T12 != _FUN_T12)
					{
						_FUN_T12 = s_fun_data.seg.T12;
					}
					 if (s_fun_data.seg.T18 != _FUN_T18)
					 {
						_FUN_T18 = s_fun_data.seg.T18;
					 }
					 if (s_fun_data.seg.T19 != _FUN_T19)
					 {
						_FUN_T19 = s_fun_data.seg.T19;
					 }
					 if (s_fun_data.seg.T20 != _FUN_T20)
					 {
						_FUN_T20 = s_fun_data.seg.T20;
					 }
					 if (s_fun_data.seg.T21 != _FUN_T21)
					 {
						_FUN_T21 = s_fun_data.seg.T21;
					 }
					 if (s_fun_data.seg.T22 != _FUN_T22)
					 {
						_FUN_T22 = s_fun_data.seg.T22;
					 }
					 if (s_fun_data.seg.T23 != _FUN_T23)
					 {
						_FUN_T23 = s_fun_data.seg.T23;
					 }
					 if (s_fun_data.seg.T24 != _FUN_T24)
					 {
						_FUN_T24 = s_fun_data.seg.T24;
					 }
					 if (s_fun_data.seg.T25 != _FUN_T25)
					 {
						_FUN_T25 = s_fun_data.seg.T25;
					 }
					 if (s_fun_data.seg.T26 != _FUN_T26)
					 {
						_FUN_T26 = s_fun_data.seg.T26;
					 }
					 if (s_fun_data.seg.T27 != _FUN_T27)
					 {
						_FUN_T27 = s_fun_data.seg.T27;
					 }
					 if (s_fun_data.seg.T28 != _FUN_T28)
					 {
						_FUN_T28 = s_fun_data.seg.T28;
					 }
					s_fun_flag = 0;
			  }		
				if (s_seg_flag)//ʾ
				{	
					if (s_seg_flag & 0x0001) 
					{
						s_seg_flag &= ~0x0001;
						LcdClearData(0);
						LcdDataSet(s_seg_data[0], 0);
					}
					if (s_seg_flag & 0x0002)
					{
						s_seg_flag &= ~0x0002;
						LcdClearData(1);
						LcdDataSet(s_seg_data[1], 1);
					}
					if (s_seg_flag & 0x0004) 
					{
						s_seg_flag &= ~0x0004;
						LcdClearData(2);
						LcdDataSet(s_seg_data[2], 2);
					}
					if (s_seg_flag & 0x0008)
					{
						s_seg_flag &= ~0x0008;
						LcdClearData(3);
						LcdDataSet(s_seg_data[3], 3);
					}
					if (s_seg_flag & 0x0010) 
					{
						s_seg_flag &= ~0x0010;
						LcdClearData(4);
						LcdDataSet(s_seg_data[4], 4);
					}
					if (s_seg_flag & 0x0020) 
					{
						s_seg_flag &= ~0x0020;
						LcdClearData(5);
						LcdDataSet(s_seg_data[5], 5);
					}
					if (s_seg_flag & 0x0040)
					{
						s_seg_flag &= ~0x0040;
						LcdClearData(6);
						LcdDataSet(s_seg_data[6], 6);
					}
					if (s_seg_flag & 0x0080)
					{
						s_seg_flag &= ~0x0080;
						LcdClearData(7);
						LcdDataSet(s_seg_data[7], 7);
					}
					if (s_seg_flag & 0x0100)
					{
						s_seg_flag &= ~0x0100;
						LcdClearData(8);
						LcdDataSet(s_seg_data[8], 8);
					}
					if (s_seg_flag & 0x0200)
					{
						s_seg_flag &= ~0x0200;
						LcdClearData(9);
						LcdDataSet(s_seg_data[9], 9);
					}
					s_seg_flag = 0;
				}
			  //hlcd.Instance->CLR = LCD_FLAG_UDD;//xixi
			  //hlcd.Instance->SR |= LCD_SR_UDR;
				s_display_num_state = LCD_DISPLAY_S2;	
				s_lcd_us_num = Timer1usGetTick();				
			}
		 	else //xixiʱ
			{
				LcdTimeOut();
			}
			break;
		}
		case LCD_DISPLAY_S2:
		{
			//if((((hlcd.Instance->SR) & LCD_FLAG_UDD)==LCD_FLAG_UDD) != RESET)//xixiжٿһ
			//if(Lcd_GetItStatus() != FALSE) //xixiܹд:ȡLCDжϱ־λINTF,ûж,ȡı־λʼΪTRUE,൱if(1)
			if(1)
			{   
				s_display_num_state = LCD_DISPLAY_S3;
			}
			else
			{
				LcdTimeOut();
			}
			break;
		}
		case LCD_DISPLAY_S3:
		{
			if ((s_fun_data.seg.T1 != _FUN_T1) || (s_fun_data.seg.T2 != _FUN_T2) || (s_fun_data.seg.T3 != _FUN_T3)	
			 || (s_fun_data.seg.T4 != _FUN_T4) || (s_fun_data.seg.T5 != _FUN_T5) || (s_fun_data.seg.T6 != _FUN_T6)	
			 || (s_fun_data.seg.T7 != _FUN_T7) || (s_fun_data.seg.T8 != _FUN_T8) 
			 || (s_fun_data.seg.T10 != _FUN_T10) || (s_fun_data.seg.T11 != _FUN_T11) || (s_fun_data.seg.T12 != _FUN_T12)
			 || (s_fun_data.seg.T18 != _FUN_T18) || (s_fun_data.seg.T19 != _FUN_T19) || (s_fun_data.seg.T20 != _FUN_T20)
			 || (s_fun_data.seg.T21 != _FUN_T21) || (s_fun_data.seg.T22 != _FUN_T22)
			 || (s_fun_data.seg.T23 != _FUN_T23) || (s_fun_data.seg.T24 != _FUN_T24) || (s_fun_data.seg.T25 != _FUN_T25)
			 || (s_fun_data.seg.T26 != _FUN_T26) || (s_fun_data.seg.T27 != _FUN_T27) || (s_fun_data.seg.T28 != _FUN_T28))	
			{
				s_fun_flag = 1;
			}			
			s_display_num_state = LCD_DISPLAY_S0;			
			break;
		}
		default:
		{
			break;
		}
	}
}

/************************************************************************************
Function: static void LcdWriteData(u8 num,u32 data1,u32 data2,u32 data3,u32 data4)
Description:дLCDʾĴ
Input:u8 num,u32 data1,u32 data2,u32 data3,u32 data4
      numȡֵΧ0~9ֶ10λá
Return:
Others:ڲӿ
************************************************************************************/
//3ABCD,4ABCDEFG,8ABCDEFG,9ABCDEFG
void LcdWriteData(u8 num,const u32 data1,const u32 data2,const u32 data3, const u32 data4)
{    
	if(data1&0X0000FFFF)//жǷеλseg
	{
		M0P_LCD->RAM0 |= (data1&0x0000FFFF);
	}
	if(data2&0X0000FFFF)//жǷеλseg
	{
	    M0P_LCD->RAM1 |= (data2&0x0000FFFF);
	}
	if(data3&0X0000FFFF)//жǷеλseg
	{
		M0P_LCD->RAM2 |= (data3&0x0000FFFF);
	}
	if(data4&0X0000FFFF)//жǷеλseg
	{
		M0P_LCD->RAM3 |= (data4&0x0000FFFF);
	}
	
	if(data1&0XFFFF0000)//жǷиλseg
	{
		M0P_LCD->RAM8 |= (data1&0xFFFF0000)>>4;
	}
	if(data2&0XFFFF0000)//жǷиλseg
	{
		M0P_LCD->RAM9 |= (data2&0xFFFF0000)>>4;
	}
	if(data3&0XFFFF0000)//жǷиλseg
	{
		M0P_LCD->RAMA |= (data3&0xFFFF0000)>>4;
	}
	if(data4&0XFFFF0000)//жǷиλseg
	{
		M0P_LCD->RAMB |= (data4&0xFFFF0000)>>4;
	}
}

/**************************************************************
Function: static void LcdDataSet(u8 lcddata_data, u8 num)
Description:ģʾ
Input:u8 lcddata_data, u8 num
Return:
Others:ڲӿ
**************************************************************/

void LcdDataSet(u8 lcddata_data, u8 num)
{
	switch (lcddata_data)
	{
		case DIS_0:
		{	//0-ABCDEF
			LcdWriteData(num, SEG_D_BUF_D1[num], (SEG_C_BUF_D2[num]|SEG_E_BUF_D2[num]), SEG_B_BUF_D3[num], (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_1:
		{////1-BC
			LcdWriteData(num, 0, SEG_C_BUF_D2[num], SEG_B_BUF_D3[num], 0);
			break;
		}
		case DIS_2:
		{//2-ABDEG
			LcdWriteData(num, SEG_D_BUF_D1[num], SEG_E_BUF_D2[num], (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), SEG_A_BUF_D4[num]);
			break;
		}
		case DIS_3:
		{//3-ABCDG
			LcdWriteData(num, SEG_D_BUF_D1[num], SEG_C_BUF_D2[num], (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), SEG_A_BUF_D4[num]);
			break;
		}
		case DIS_4:
		{//4-BCFG
			LcdWriteData(num, 0, SEG_C_BUF_D2[num], (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), SEG_F_BUF_D4[num]);
			break;
		}
		case DIS_5:
		{//5-ACDFG
			LcdWriteData(num, SEG_D_BUF_D1[num], SEG_C_BUF_D2[num], SEG_G_BUF_D3[num], (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_6:
		{//6-ACDEFG
			LcdWriteData(num, SEG_D_BUF_D1[num], (SEG_C_BUF_D2[num]|SEG_E_BUF_D2[num]), SEG_G_BUF_D3[num], (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_7:
		{//7-ABC
			LcdWriteData(num, 0, SEG_C_BUF_D2[num], SEG_B_BUF_D3[num], SEG_A_BUF_D4[num]);
			break;
		}
		case DIS_8:
		{//8-ABCDEFG
			LcdWriteData(num, SEG_D_BUF_D1[num], (SEG_C_BUF_D2[num]|SEG_E_BUF_D2[num]), (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_9:
		{//9-ABCDFG
			LcdWriteData(num, SEG_D_BUF_D1[num], SEG_C_BUF_D2[num], (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
	
		case DIS_A:
		{//A-ABCDFG
			LcdWriteData(num, 0, (SEG_C_BUF_D2[num]|SEG_E_BUF_D2[num]), (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_B:
		{//B-CDEFG
			LcdWriteData(num, SEG_D_BUF_D1[num], (SEG_C_BUF_D2[num]|SEG_E_BUF_D2[num]), SEG_G_BUF_D3[num], SEG_F_BUF_D4[num]);
			break;
		}
		case DIS_C:
		{//C-ADEF
			LcdWriteData(num, SEG_D_BUF_D1[num], SEG_E_BUF_D2[num], 0, (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_D:
		{//D-BCDEG
			LcdWriteData(num, SEG_D_BUF_D1[num], (SEG_C_BUF_D2[num]|SEG_E_BUF_D2[num]), (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), 0);
			break;
		}
		case DIS_E:
		{//E-ADEFG
			LcdWriteData(num, SEG_D_BUF_D1[num], SEG_E_BUF_D2[num], SEG_G_BUF_D3[num], (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_F:
		{//F-AEFG
			LcdWriteData(num, 0, SEG_E_BUF_D2[num], SEG_G_BUF_D3[num], (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_P:
		{//P-ABEFG
			LcdWriteData(num, 0, SEG_E_BUF_D2[num], (SEG_B_BUF_D3[num]|SEG_G_BUF_D3[num]), (SEG_A_BUF_D4[num]|SEG_F_BUF_D4[num]));
			break;
		}
		case DIS_t:
		{//t-DEFG
			LcdWriteData(num, SEG_D_BUF_D1[num], SEG_E_BUF_D2[num], SEG_G_BUF_D3[num], SEG_F_BUF_D4[num]);
			break;
		}
		case DIS_HG:
		{//'-'-G
			LcdWriteData(num, 0, 0, SEG_G_BUF_D3[num], 0);
			break;
		}
		case DIS_BLANK:
		{
			LcdClearData(num);
			break;
		}
		default:
		{
			break;
		}
	}
}


/*************************************************
Function: static void LcdClearData(u8 num)
Description:LCDʾĴ
Input:u8 num  numȡֵΧ0~9ֶ10λá
Return:
Others:ڲӿ
*************************************************/
//3ABCD,4ABCDEFG,8ABCDEFG,9ABCDEFG
 void LcdClearData(u8 num)
{
	if((num==3)||(num==7)||(num==8))//4\8\9ǸλSEG
	{
		M0P_LCD->RAM8 &= ~(SEG_D_BUF_D1[num]>>4);
		M0P_LCD->RAM9 &= ~((SEG_C_BUF_D2[num]>>4) | (SEG_E_BUF_D2[num]>>4));
		M0P_LCD->RAMA &= ~((SEG_B_BUF_D3[num]>>4) | (SEG_G_BUF_D3[num]>>4));
		M0P_LCD->RAMB &= ~((SEG_A_BUF_D4[num]>>4) | (SEG_F_BUF_D4[num]>>4));
	}
	else if((num==2))
	{
		M0P_LCD->RAMB &= ~(SEG_A_BUF_D4[num]>>4);
		M0P_LCD->RAMA &= ~(SEG_B_BUF_D3[num]>>4);
		M0P_LCD->RAM9 &= ~(SEG_C_BUF_D2[num]>>4);
		M0P_LCD->RAM8 &= ~(SEG_D_BUF_D1[num]>>4);		
		M0P_LCD->RAM1 &= ~(SEG_E_BUF_D2[num]);
		M0P_LCD->RAM3 &= ~(SEG_F_BUF_D4[num]);
		M0P_LCD->RAM2 &= ~(SEG_G_BUF_D3[num]);	
	}
	else
	{
		M0P_LCD->RAM0 &= ~(SEG_D_BUF_D1[num]);
		M0P_LCD->RAM1 &= ~(SEG_C_BUF_D2[num] | SEG_E_BUF_D2[num]);
		M0P_LCD->RAM2 &= ~(SEG_B_BUF_D3[num] | SEG_G_BUF_D3[num]);
		M0P_LCD->RAM3 &= ~(SEG_A_BUF_D4[num] | SEG_F_BUF_D4[num]);
	}  
}
/*******************************************************/
/*******************************************************/
/********************Ĵ붼߼Ե*************/
/*******************************************************/
/*******************************************************/


/****************************************************
Function: void LcdDisplayData(u8 position, u8 data)
Description:LCDʾ
Input:u8 positionλ  u8 dataҪʾ
Return:
Others:MainSpaceڶӿڣӿ
****************************************************/
void LcdDisplayData(u8 position, u8 data)
{
	 if (position < 10)//gaishanxiugai
    {
        s_seg_flag |= (1 << position);
        if ( data < DIS_ALL_NUM)
        {
            s_seg_data[position] = data;
        }
        else
        {
            s_seg_data[position] = 19;
        }
    }
}

/*************************************************
Function: u8 LcdGetDisplayData(u8 position)
Description:ȡLCDǰʾ
Input:u8 positionȡʾֵλ
Return:ǰʾ
Others:Mainspaceڶӿڣӿ
*************************************************/
u8 LcdGetDisplayData(u8 position)
{
	if (position < 10)//gaishanxiugai
	{
		return s_seg_data[position];
	}
	else
	{
		return 0xEE;
	}
}

/*************************************************
Function: void LcdDisplayFun(u32 fun)
Description:lcdʾַ̻
Input:u32 funλĹַ̻
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdDisplayFun(u32 fun)
{
    s_fun_flag = 1;
    if (s_valve_state == 0)
    {
        s_fun_data.word = (fun &(~FUN_VALVE_CLOSE)); //ſĬϷſ
       
    }
    else if (s_valve_state == 1)
    {
        
      s_fun_data.word =fun | FUN_VALVE_CLOSE;//Ź

    }
//    else
//    {
//        s_fun_data.word = fun & (~FUN_VALVEOPEN);
//        s_fun_data.word &= (~FUN_VALVECLOSE);
//    }
    if (s_val_state)
    {
        s_fun_data.word |= FUN_BATTERY_LOW ; //Ƿѹ־λ
    }
    else
    {
        s_fun_data.word &= (~FUN_BATTERY_LOW );
    }
    if (s_low_flow_state)
    {
        s_fun_data.word |= FUN_FLOW_LOW ; //־λ
    }
    else
    {
        s_fun_data.word &= (~FUN_FLOW_LOW );
    }
    if (s_alarm_state)
    {
        s_fun_data.word |= FUN_ALARM; //
    }
    else
    {
        s_fun_data.word &= (~FUN_ALARM);
    }
    if (s_failure_state)
    {
        s_fun_data.word |= FUN_MALFUNCTION; //
    }
    else
    {
        s_fun_data.word &= (~FUN_MALFUNCTION);
    }
    if (s_active_RF_state)
    {
        s_fun_data.word |= FUN_GPRSING ; //߻Ծ
    }
    else
    {
        s_fun_data.word &= (~FUN_GPRSING );
    }
   /* if (s_yuan_state)
    {
        s_fun_data.word |= FUN_YUAN; //Ԫ
    }
    else
    {
        s_fun_data.word &= (~FUN_YUAN);
    }
    if (s_pay_money_state)
    {
        s_fun_data.word |= FUN_JF; //ɷ
    }
    else
    {
        s_fun_data.word &= (~FUN_JF);
    }
    if (s_price_state)
    {
        s_fun_data.word |= FUN_DJ ; //
    }
    else
    {
        s_fun_data.word &= (~FUN_DJ );
    }
    if (s_lost_state)
    {
        s_fun_data.word |= FUN_SY; //ʣ
    }
    else
    {
        s_fun_data.word &= (~FUN_SY);
    }
    if (s_buy_state)
    {
        s_fun_data.word |= FUN_GR; //
    }
    else
    {
        s_fun_data.word &= (~FUN_GR);
    }*/
}

/*************************************************
Function: u32 LcdGetDisplayFun(void)
Description:ȡlcdǰʾĹַ̻
Input:
Return:ǰʾַ
Others:Mainspaceڶӿڣӿ
*************************************************/
u32 LcdGetDisplayFun(void)
{
	return s_fun_data.word;
}

/*************************************************
Function: void LcdDisplayAll(void)
Description:LCDȫ
Input:
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdDisplayAll(void)
{
	s_fun_flag = 1;
	s_fun_data.word = 0x0FFFFFFF;
	LcdDisplayData(0, DIS_8); 
	LcdDisplayData(1, DIS_8); 
	LcdDisplayData(2, DIS_8); 
	LcdDisplayData(3, DIS_8); 
	LcdDisplayData(4, DIS_8); 
	LcdDisplayData(5, DIS_8); 
	LcdDisplayData(6, DIS_8); 
	LcdDisplayData(7, DIS_8); 
	LcdDisplayData(8, DIS_8); //gaishanxiugai
	LcdDisplayData(9, DIS_8); 
}


/*************************************************
Function: void LcdClearAll(void)
Description:LCD
Input:
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdClearAll(void)
{
	s_fun_flag = 1;
	s_fun_data.word = 0;
	LcdDisplayData(0, DIS_BLANK); 
	LcdDisplayData(1, DIS_BLANK); 
	LcdDisplayData(2, DIS_BLANK); 
	LcdDisplayData(3, DIS_BLANK); 
	LcdDisplayData(4, DIS_BLANK); 
	LcdDisplayData(5, DIS_BLANK); 
	LcdDisplayData(6, DIS_BLANK); 
	LcdDisplayData(7, DIS_BLANK); 	
	LcdDisplayData(8, DIS_BLANK); 	//gaishanxiugai
	LcdDisplayData(9, DIS_BLANK); 	
}

/*************************************************
Function: u8 LcdIfSleep(void)
Description:LCDǷ
Input:
Return:TRUEFALSE
Others:Mainspaceӿڣǰӿ
*************************************************/
u8 LcdIfSleep(void)//ǰӿ
{
	if ( s_display_num_state == 0 && s_fun_flag == 0 && s_seg_flag == 0)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

/*************************************************
Function: void LcdPreSleep(void)
Description:LCDǰ
Input:
Return:
Others:Mainspaceӿڣǰӿ
*************************************************/
void LcdPreSleep(void)
{
    //nothing
}

/*************************************************
Function: void LcdWakeSleep(void)
Description:LCDѺ
Input:
Return:
Others:Mainspaceӿڣѽӿ
*************************************************/
void LcdWakeSleep(void)//Ѻӿ
{
    //nothing
}

/*************************************************
Function: void LcdDisplayValve(u8 flag)
Description:lcdʾ״̬
Input:u8 flag1ط0 Ĭϲʾ
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdDisplayValve(u8 flag)
{
	s_fun_flag = 1;
	if (flag == 1)
	{
		s_valve_state = 1; //T7:Ź
		s_fun_data.seg.T7 = 1;
	}
	else 
	{
		s_valve_state = 0; //T7:ſ
		s_fun_data.seg.T7 = 0;
	}
	
}

/*************************************************
Function: void LcdDisplayVol(u8 flag)
Description:lcdʾ
Input:u8 flag1Ƿѹ0
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdDisplayVol(u8 flag)
{
	s_fun_flag = 1;
	if (flag)
	{
		s_val_state = 1;
		s_fun_data.seg.T5 = 1;
	}
	else
	{
		s_val_state = 0;
		s_fun_data.seg.T5 = 0;
	}
}

/*************************************************
Function: void LcdDisplayAlarm(u8 flag)
Description:lcdʾ
Input:u8 flag10
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdDisplayAlarm(u8 flag)
{
	s_fun_flag = 1;
	if (flag)
	{
		s_alarm_state = 1;
		s_fun_data.seg.T1 = 1;
	}
	else
	{
		s_alarm_state = 0;
		s_fun_data.seg.T1 = 0;
	}
}
/*************************************************
Function: void LcdDisplayLowFlowAlarm(u8 flag)
Description:lcd 
Input:u8 flag10
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdDisplayLowFlowAlarm(u8 flag)
 {
  s_fun_flag=1;
	 if(flag)
	 {
	  s_low_flow_state=1;
		s_fun_data.seg.T4 =1;
		 
	 }
	 else
	 {
	 s_low_flow_state=0;
		s_fun_data.seg .T4 =0;
	 }
 }
 /*************************************************
Function: void LcdDisplayFailure(u8 flag)
Description:lcd ϼ
Input:u8 flag10
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
 void LcdDisplayFailure(u8 flag)
 {
   s_fun_flag=1;
	 if(flag)
	 {
	   s_failure_state=1;
		 s_fun_data.seg .T2=1;
	 }
	 else
	 {
	  s_failure_state=0;
		 s_fun_data.seg.T2=0;
	 }
 }
 

/*************************************************
Function: void LcdDisplayActiveGPRS(u8 flag)
Description:lcdʾGPRSͨ
Input:u8 flag1ͨţ0
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
void LcdDisplayActiveGPRS(u8 flag)
{
	s_active_RF_state = flag;
	if(s_active_RF_state_old != s_active_RF_state)
	{
		s_active_RF_state_old = s_active_RF_state;
		s_fun_flag = 1;
		if (flag)
		{
			s_active_RF_state = 1;
			s_fun_data.seg.T3 = 1;
		}
		else
		{
			s_active_RF_state = 0;
			s_fun_data.seg.T3 = 0;
		}
	}
}
/*************************************************
Function: void LcdDisplayYuan(u8 flag)
Description:lcdʾ֡Ԫ
Input:u8 flagNone
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
/*void LcdDisplayYuan(u8 flag)
{
    s_fun_flag = 1;
    if (flag)
    {
        s_yuan_state = 1;
        s_fun_data.seg.T13 = 1;
    }
    else
    {
        s_yuan_state = 0;
        s_fun_data.seg.T13 = 0;
    }
}
*/
/*************************************************
Function: void LcdDisplayPrice(u8 flag)
Description:lcdʾ֡ۡ
Input:u8 flagNone
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
/*void LcdDisplayPrice(u8 flag)
{
	s_fun_flag = 1;
    if (flag)
    {
        s_price_state = 1;
        s_fun_data.seg .T15 = 1;
    }
    else
    {
        s_price_state = 0;
        s_fun_data.seg .T15= 0;
    }
	}
*/
/*************************************************
Function: void LcdDisplayPleasePay(u8 flag)
Description:lcdʾɷ
Input:u8 flag1ɷѣ0
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
/*void LcdDisplayPleasePay(u8 flag)
{
	s_fun_flag = 1;
	if (flag)
	{
		s_pay_money_state= 1;
		s_fun_data.seg.T17 = 1;
	}
	else
	{
		s_pay_money_state = 0;
		s_fun_data.seg.T17 = 0;
	}
}
*/
/*************************************************
Function:   void LcdDisplaySurplus(u8 flag)
Description:lcdʾ֡ʣࡱ
Input:u8 flagNone
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
/*void LcdDisplaySurplus(u8 flag)
{
 s_fun_flag = 1;
    if (flag)
    {
        s_lost_state = 1;
        s_fun_data.seg.T14 = 1;
    }
    else
    {
        s_lost_state = 0;
        s_fun_data.seg.T14 = 0;
    }
}*/
/*************************************************
Function:   void LcdDisplayBuy(u8 flag)
Description:lcdʾ֡롱
Input:u8 flagNone
Return:
Others:Mainspaceڶӿڣӿ
*************************************************/
/*void LcdDisplayBuy(u8 flag)
{
    s_fun_flag = 1;
    if (flag)
    {
        s_buy_state = 1;
        s_fun_data.seg.T16 = 1;
    }
    else
    {
        s_buy_state = 0;
        s_fun_data.seg.T16 = 0;
    }
}
*/
/*************************************************
Function: void LcdDisplayEnable(void)
Description:ʹLCDʾ
Input:
Return:
Others:MainSpaceڶӿڣӿ
*************************************************/
//xixiƽ̨
void LcdDisplayEnable(void)
{
  M0P_LCD->CR0_f.EN = LcdEnable;//LCD
}

/*************************************************
Function: void LcdDisplayDisable(void)
Description:رLCDʾ
Input:
Return:
Others:MainSpaceڶӿڣӿ
*************************************************/
//xixiƽ̨
void LcdDisplayDisable(void)
{
  M0P_LCD->CR0_f.EN = LcdDisable;//رLCD
}


/*******************************************************
Function: static void LcdTimeOut(void)
Description:LCDʱ
Input:void
Return:
Others:ڲӿ
*******************************************************/
static void LcdTimeOut(void)
{   
	if ((Timer1usGetTick() - s_lcd_us_num) > LCD_TIMEOUT_VALUE)
	{
		s_fun_flag = 0;	
		s_seg_flag = 0;	
		s_display_num_state = LCD_DISPLAY_S0;					
	}
}

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/

